//
//  MFEngine.h
//  Amigo
//
//  Created by Morgan Redman on 04/06/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//


#import <Cocoa/Cocoa.h>

#define kFaceBookAPIKey  @"ef0226a7d1168abecd29129819cd9d77"
#define kFaceBookSecret @"a0c4e629180b6161a0f3a355a5f145b3"

@class MKFacebook;
@class OBJXArchive;
@class OBJXDownloadManager;

@interface MFEngine : NSObject {
	MKFacebook *mFaceBookConnection;
	NSArray *mFriends;
	NSArray *mFriendRequests;
	NSArray *mEvents;
	//NSArray *mPokes;
	int mPokes;
	int mLastPoke;
	int mMessages;
	int mLastMessage;
	BOOL mConnected;
	BOOL mAutoConnect;
	IBOutlet id controller;
	NSString *mSettingsAction;
	NSTimer *mNotificationsTimer;
	NSTimer *mFriendsTimer;
	int mConnectionAttempts;
	IBOutlet OBJXArchive *archive;
}

- (void)launchSettings;

- (BOOL)connected;

- (void)checkIfWeAreConnected;
- (void)checkInternetAvailability;

- (void)downloadPicturesForFriends:(NSArray*)array;

+ (NSArray*)friendsFromXML:(NSXMLDocument*)document;
+ (NSArray*)eventsFromXML:(NSXMLDocument*)document;



#pragma mark Accessor Methods
- (void)setFaceBookConnection:(MKFacebook*)faceBook;
- (MKFacebook*)faceBookConnection;

- (NSArray*)friends;
- (void)setFriends:(NSArray*)friends;

- (void)setFriendRequests:(NSArray*)friends;
- (NSArray*)friendRequests;

- (void)setEvents:(NSArray*)events;
- (NSArray*)events;

//- (void)setPokes:(NSArray*)pokes;
//- (NSArray*)pokes;
- (int)pokes;
- (int)lastPoke;
- (int)messages;
- (int)lastMessage;

#pragma mark Facebook Delegate Methods
- (void)userLoginSuccessful;

#pragma mark Private Methods
- (void)mergeFriends:(NSArray*)newFriends;
- (void)disconnected;

@end
