//MFFriend.h
#import <Cocoa/Cocoa.h>

@class OBJXDownload;
@class MFDocument;

@interface MFFriend : NSObject <NSCoding> {
	NSString *mId;
	NSString *mFirstName;
	NSString *mLastName;
	//NSImage *mImage;
	
	NSString *mStatus;
	int mWallCount;
	
	NSString *mSmallPictureCacheKey;
	NSString *mSmallPictureId;
	NSString *mLargePictureCacheKey;
	NSString *mLargePictureId;
	
	MFDocument *mDocument; //not retained
}

- (id)init;
- (void)dealloc;

- (id)initWithCoder:(NSCoder *)coder;
- (void)encodeWithCoder:(NSCoder *)coder;
- (void)copyFriend:(MFFriend*)copy;

#pragma mark Methods
- (NSString*)fullName;

#pragma mark URLs
- (NSURL*)profileURL;
- (NSURL*)pokeURL;
- (NSURL*)messageURL;
- (NSURL*)photosByUserURL;
- (NSURL*)photosOfUserURL;
- (NSURL*)usersWallURL;
- (NSURL*)notesURL;
- (NSURL*)addFriendURL;

#pragma mark Accessor Methods
- (void)setUid:(NSString *)theId;
- (NSString *)uid;
- (void)setFirstName:(NSString *)theFirstName;
- (NSString *)firstName;
- (void)setLastName:(NSString *)theLastName;
- (NSString *)lastName;
- (NSString*)firstNameFirst;//derived
- (void)setFirstNameFirst:(NSString*)s;//stub
- (NSString*)lastNameFirst;//derived
- (void)setLastNameFirst:(NSString*)s;//stub

- (void)setWallCount:(int)count;
- (int)wallCount;
- (void)setStatus:(NSString*)value;
- (NSString*)status;

- (void)setSmallPictureId:(NSString *)theSmallPictureId;
- (NSString *)smallPictureId;
- (void)setDocument:(MFDocument*)document;
- (MFDocument*)document;

- (void)setSmallPictureCacheKey:(NSString *)theSmallPictureCacheKey;
- (NSString *)smallPictureCacheKey;
- (void)setLargePictureCacheKey:(NSString *)theLargePictureCacheKey;
- (NSString *)largePictureCacheKey;
- (void)setLargePictureId:(NSString *)theLargePictureId;
- (NSString *)largePictureId;
- (NSImage*)largePictureImage;
- (NSImage*)smallPictureImage;
@end
