/*
 Copyright (c) 2007, Mike Kinney
 All rights reserved.
 
 Redistribution and use in source and binary forms, with or without modification, are permitted provided that the 
 following conditions are met:
 
 * Redistributions of source code must retain the above copyright notice, this list of conditions and the 
 following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the 
 following disclaimer in the documentation and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
 SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE 
 USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */
//
//  MKFacebookMethods.m
//  MKAbeFook
//
//  Created by Mike on 11/27/06.
//  Copyright 2006 Mike Kinney. All rights reserved.
//


#import "MKFacebook.h"
@interface MKFacebook (MKFacebookMethods) 
#pragma mark XML Returning Methods
#pragma mark FQL
-(id)facebookFQLQuery:(NSString *)aQuery;

#pragma mark -
#pragma mark Events
-(id)facebookEventsGet:(int)aUid eids:(NSArray *)eids startTime:(int)startTime endTime:(int)endTime rsvpStatus:(NSString *)rsvpStatus;
-(id)facebookEventsGetMembers:(NSString *)eid;
#pragma mark -

#pragma mark Friends
-(id)facebookFriendsGet;
-(id)facebookFriendsGetAppUsers;
-(id)facebookFriendsAreFriends:(NSArray *)id1 id2:(NSArray *)id2;
#pragma mark -

#pragma mark Groups
-(id)facebookGroupsGet:(int)aUid gids:(NSArray *)gids;
-(id)facebookGroupsGetMembers:(NSString *)gid;
#pragma mark -

#pragma mark Notifications
-(id)facebookNotificationsGet;
#pragma mark -

#pragma mark Photos
-(id)facebookPhotosAddTag:(NSString *)aPid tagUid:(int)aTagUid tagText:(NSString *)aTagText x:(float)aX y:(float)aY;
-(id)facebookPhotosCreateAlbum:(NSString *)aName location:(NSString *)aLocation description:(NSString *)aDescription;
-(id)facebookPhotosGet:(int)subjId aid:(NSString *)aid pids:(NSArray *)pids;
-(id)facebookPhotosGetAlbums:(int)aUid pids:(NSArray *)pids;
-(id)facebookPhotosGetTags:(NSArray *)pids;
#pragma mark -

#pragma mark Update
-(id)facebookUpdateDecodeIDs:(NSArray *)ids;
#pragma mark -

#pragma mark Users
-(id)facebookUsersGetInfo:(NSArray *)uids fields:(NSArray *)fields;
-(id)facebookUsersGetLoggedInUser;
#pragma mark -


#pragma mark URL Returning Methods
#pragma mark FQL
-(NSURL *)facebookFQLQueryURL:(NSString *)aQuery;
#pragma mark -

#pragma mark Events
-(NSURL *)facebookEventsGetURL:(int)aUid eids:(NSArray *)eids startTime:(int)startTime endTime:(int)endTime rsvpStatus:(NSString *)rsvpStatus;
-(NSURL *)facebookEventsGetMembersURL:(NSString *)eid;
#pragma mark -

#pragma mark Friends
-(NSURL *)facebookFriendsGetURL;
-(NSURL *)facebookFriendsGetAppUsersURL;
-(NSURL *)facebookFriendsAreFriendsURL:(NSArray *)id1 id2:(NSArray *)id2;
#pragma mark -

#pragma mark Groups
-(NSURL *)facebookGroupsGetURL:(int)aUid gids:(NSArray *)gids;
-(NSURL *)facebookGroupsGetMembersURL:(NSString *)gid;
#pragma mark -

#pragma mark Notifications
-(NSURL *)facebookNotificationsGetURL;
#pragma mark -

#pragma mark Photos
-(NSURL *)facebookPhotosAddTagURL:(NSString *)aPid tagUid:(int)aTagUid tagText:(NSString *)aTagText x:(float)aX y:(float)aY;
-(NSURL *)facebookPhotosCreateAlbumURL:(NSString *)aName location:(NSString *)aLocation description:(NSString *)aDescription;
-(NSURL *)facebookPhotosGetURL:(int)subjId aid:(NSString *)aid pids:(NSArray *)pids;
-(NSURL *)facebookPhotosGetAlbumsURL:(int)aUid pids:(NSArray *)pids;
-(NSURL *)facebookPhotosGetTagsURL:(NSArray *)pids;
#pragma mark -

#pragma mark Update
-(NSURL *)facebookUpdateDecodeIDsURL:(NSArray *)ids;
#pragma mark -

#pragma mark Users
-(NSURL *)facebookUsersGetInfoURL:(NSArray *)uids fields:(NSArray *)fields;
-(NSURL *)facebookUsersGetLoggedInUserURL;



@end
