//OBJXCache.h
#import <Cocoa/Cocoa.h>

@interface OBJXCache : NSObject <NSCoding> {
	NSString *mPath;
	int mCacheCapacity;
	NSMutableArray *mQueue;
	NSMutableSet *mKeys;
    NSMutableDictionary *mCache;
}

- (id)init;
- (void)dealloc;


- (NSString*)keyForData:(NSData*)data;
- (NSData*)dataForKey:(NSString*)key;
- (BOOL)containsKey:(NSString*)key;
- (void)removeKey:(NSString*)key;
- (void)trimQueue;
- (NSString*)newKey;
- (NSString*)pathForKey:(NSString*)key;
- (NSArray*)newKeyAndPath;//Only really for OBJXDownloadManager
- (void)cleanCacheFolder;

- (id)initWithCoder:(NSCoder *)coder;
- (void)encodeWithCoder:(NSCoder *)coder;
//Accessor Methods
- (void)setPath:(NSString *)thePath;
- (NSString *)path;
- (void)setCacheCapacity:(int)theCacheCapacity;
- (int)cacheCapacity;
- (void)setQueue:(NSMutableArray*)theQueue;
- (NSMutableArray*)queue;
- (void)setKeys:(NSMutableSet*)theKeys;
- (NSMutableSet*)keys;


@end
