#import <Cocoa/Cocoa.h>

@class OBJXDownload;

@protocol OBJXDownloadDelegateProtocol
    - (void)processDownload:(OBJXDownload*)download;
@end

@interface OBJXDownload : NSObject {
    id <OBJXDownloadDelegateProtocol>mDelegate;
    NSURL *mURL;
    NSURLConnection *mConnection;
    NSMutableData *mData;
    BOOL mSuccess;
	
	//Used from an OBJXDownloadManager
	id mTargetObject;
	NSString* mCacheKeyPathName;
}

+ (id)downloadWithURL:(NSURL*)url delegate:(id)delegate;

- (void)download;

#pragma mark Download Methods
- (void)connection:(NSURLConnection*)connection didReceiveResponse:(NSURLResponse*)response;
- (void)connection:(NSURLConnection*)connection didReceiveData:(NSData*)newData;
- (void)connection:(NSURLConnection*)connection didFailWithError:(NSError*)error;
- (void)connectionDidFinishLoading:(NSURLConnection*)connection;

#pragma markAccessor Methods
- (void)setDelegate:(id)delegate;
- (id)delegate;
- (void)setUrl:(NSURL*)url;
- (NSURL*)url;
- (void)setConnection:(NSConnection*)connection;
- (NSConnection*)connection;
- (void)setData:(NSMutableData*)data;
- (NSMutableData*)data;
- (void)setSuccess:(BOOL)value;
- (BOOL)success;

- (void)setCacheKeyPathName:(NSString*)theCacheKeyPathName;
- (NSString*)cacheKeyPathName;
- (void)setTargetObject:(id)object;
- (id)targetObject;
@end
