
#import <Cocoa/Cocoa.h>
#import "OBJXDownload.h"

@class OBJXCache;
@class OBJXDownloadManagerEngine;

@protocol OBJXDownloadManagerDelegateProtocol
   // - (void)processDownload:(OBJXDownload*)download;
	- (void)processDownloadSuccess:(NSURL*)url;
@end

//This protocol is optional for targets as used in one of the download methods
@protocol OBJXDownloadManagerTargetProtocol
- (void)processDownloadForCacheKeyPathName:(NSString*)key success:(BOOL)success;
@end

@protocol OBJXDownloadManagerEngineProtocol
- (void)downloadURL:(NSString*)urlString toObject:(id)object cacheKeyPathName:(NSString*)cacheKeyPathName;
@end



@interface OBJXDownloadManager : NSObject {
	id <OBJXDownloadManagerDelegateProtocol>mDelegate;
	OBJXCache *mCache;
	
	//Engine Connection and Proxy
	NSConnection *mEngineConnection;
	id <OBJXDownloadManagerEngineProtocol>mEngine;
   
    
     NSMutableDictionary *mDownloads;
}

#pragma mark Public
- (void)downloadURL:(NSURL*)url toObject:(id)object cacheKeyPathName:(NSString*)cacheKeyPathName;


- (void)setCache:(OBJXCache*)theCache;
- (OBJXCache*)cache;
- (void)setEngine:(id)engine;
- (id)engine;

//- (void)downloadURLString:(NSString*)string;
//- (void)downloadURL:(NSURL*)url;

//- (void)addOutput:(OBJXDownload*)download;
//- (oneway void)notifyDelegateOfOutput;

- (void)setDelegate:(id)delegate;
- (id)delegate;

#pragma mark Private
- (void)installEngine;

@end
