#import <Cocoa/Cocoa.h>

@class OBJXDownloadManager;

@protocol OBJXDownloadManagerEngineDelegateProtocol
- (NSArray*)newKeyAndPathFromQueue;
- (oneway void)processDownloadSuccess:(bycopy NSURL*)url;
@end

@interface OBJXDownloadManagerEngine : NSObject {
    NSMutableArray *mDownloadQueue; //For NSURLs waiting to be downloaded
    NSMutableArray *mDownloads;
    BOOL mRunning;
    NSConnection *mConnection;
	
	id <OBJXDownloadManagerEngineDelegateProtocol>mClient;//Proxy to OBJXDownloadManager
}

- (void)commonInit;

+ (void)connectWithPorts:(NSArray*)ports;
- (OBJXDownloadManager *) initWithConnection:(NSConnection*)connection;


- (void)setClient:(id)object;
- (id)client;

@end
