//  OBJXJob.h
//  OBJXFoundation

//  Created by Morgan Redman on 29/04/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.

#import <Cocoa/Cocoa.h>
@class OBJXJob;

@protocol OBJXJobDelegate
    - (void)processJob:(OBJXJob*)job;
@end

@protocol OBJXJobSubClass
    - (void)processJob:(OBJXJob*)job;
@end

@interface OBJXJob : NSObject {
    NSMutableDictionary *mSharedDictionary;
 //   id <OBJXJobSubClass>mDelegate;
    OBJXJob *mServerObject;
    NSConnection *mConnection;
    BOOL mQuit; //Flag for server thread / semaphore
    id mDelegate;
}

//For shared data
- (void)setSharedObject:(id)object forKey:(NSString*)key;
- (id)sharedObjectForKey:(NSString*)key;

- (void)start;
- (void)complete;
- (void)cleanup; //Call before dealloc to clean up
- (BOOL)shouldExit;

- (void)thread:(id)ports;

- (void)setSharedDictionary:(NSMutableDictionary*)theSharedDictionary;
- (NSMutableDictionary*)sharedDictionary;
- (void)setServer:(OBJXJob*)server;
- (OBJXJob*)server;
@end
