//OBJXMenuView.h
#import <Cocoa/Cocoa.h>

@class OBJXMenuItemCell;

#define kOBJXMenuViewScrollDelay 0.04

@interface OBJXMenuView : NSView   {
	NSWindow* mWindow;//JUNO_FIXME dont need this i dont think
	OBJXMenuItemCell *mCell;
	NSMenu* mMenuContent;
	OBJXMenuView *mSubmenuView;
	
	int mVisibleIndex; //Index into menu items
	int mSelectedIndex;// -1 for not selected
	int mOldSelectedIndex;
	
	//NSTrackingRectTag mTrackingRectTag;
	IBOutlet id parentWindow;//for what ever reason [self window] is not working for us ( maybe cause its in a panel ?? ). parentWindow must be manually  connected to the parent window
	
	//MouseTracking
	NSPoint mOldMouseLoc;//Used during mouse tracking - cause i cant figure out how to get mouse tracking to work!!
	NSTimer *mMouseTrackingTimer;
	BOOL mKeyboardNavigation;//True when mouse tracking loop should only update if mouse has moved
	
	NSDate *mLastScrollTime;
	BOOL mBottomScroller;
	
	//Selecting Animation
	BOOL mSelecting;
	int mFrame;
	NSTimer *mSelectingTimer;
}

- (id)init;
- (void)dealloc;


+ (float)separatorHeight;
- (void)startTracking;
- (void)stopTracking;

- (void)handleBottomScroller;
- (void)handleTopScroller;

- (void)autoSelectItem;

//Geometry
- (NSRect)topScrollerRect;
- (NSRect)bottomScrollerRect;
- (float)contentHeight;
- (NSRect)cellRectForMenuItem:(id)menuItem;
+ (float)heightForMenuItem:(NSMenuItem*)item;

//Keyboard navigation
- (void)activateKeyboardNavigation;
- (void)deactivateKeyboardNavigation;
- (BOOL)keyboardNavigation;

//Accessor Methods
- (void)setWindow:(NSWindow*)theWindow;
- (NSWindow*)window;
- (void)setMenuContent:(NSMenu*)menu;
- (NSMenu*)menuContent;
- (int)selectedIndex;
- (void)setSelectedIndex:(int)index;
- (id)selectedItem;
- (id)parentWindow;
- (void)setSubmenuView:(OBJXMenuView*)theSubmenuView;
- (OBJXMenuView*)submenuView;

@end
